/*
 *  es1e2.c
 *  
 *
 *  Created by Emanuela Fachini on 23/04/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

struct nodo {
 int elem;
 struct nodo * next;
};

typedef  struct nodo Lista; 

typedef  Lista * ListaPtr; 
/* sol1*/
ListaPtr dividiMult3It (ListaPtr *L) 
/*separa la lista in  due liste, la prima contiene i multipli di 3 e la seconda i rimanenti
nello stesso ordine che avevano nella lista di partenza e senza allocare memoria.
postc: restituisce la lista dei multipli di 3 di L, estratti da L (nello stesso ordine in cui si trovano in L ) */
{ListaPtr app = *L,mult3 = NULL,nMult3 = NULL, temp1 = NULL, temp2 = NULL;
/* mult3 e nMult3 sono i puntatori iniziali alle liste da costruire, mentre temp1 e temp2 servono per
scorrere le due liste man mano che si costruiscono*/
if (!app) return NULL;
while ( app ) 
	{if ( app->elem %3 == 0)
			{if (temp1)  {temp1 -> next = app; temp1 = temp1 -> next;} /*predispongo l'aggancio del prossimo elemento*/
			else {mult3 = app;temp1 = app;} /*ho trovato il primo multiplo di tre, sara' alla testa della lista mult3*/
			}
	else 
	{if (temp2) { temp2 -> next = app; temp2 = temp2  -> next;} /*predispongo l'aggancio del prossimo elemento*/
	else {nMult3 = app;temp2 = app;} /*ho trovato il primo non  multiplo di tre, sara' alla testa della lista mult3*/
	}
app = app -> next;
	}
*L = nMult3;
if (temp1) temp1 ->next = NULL; 
/* l'ultimo multiplo di tre agganciato , se non e' l'ultimo elemento della lista, 
ha un puntatore nel campo next al prossimo elemento che e' un multiplo di 3, quindi devo annullare quel puntatore*/ 
if (temp2) temp2 ->next = NULL;
/*come per temp1. I  puntatori temp1 o temp2  potrebbero essere NULL nel caso la lista 
fosse costituita da tutti multipli di tre o tutti non multipli di 3 */
return mult3;}

/* sol2*/
ListaPtr dividiMult3 (ListaPtr *L)
/*separa la lista in  due liste, la prima contiene i multipli di 3 e la seconda i rimanenti
nello stesso ordine che avevano nella lista di partenza e senza allocare memoria.
postc: restituisce la lista dei multipli di 3 di L, estratti da L (nello stesso ordine in cui si trovano in L ) */
{ListaPtr app= *L,mult3,temp1 = NULL,temp2= NULL, altri = NULL;
if (!app) return NULL;
while (app)
{if (app-> elem %3==0) insFine(&mult3,&temp1,app);
else insFine(&altri,&temp2,app);
app = app->next;}
if (temp1) temp1 -> next = NULL;
if (temp2) temp2 -> next = NULL;
*L = mult3;
return altri;
}


void insFine( ListaPtr *lista, ListaPtr *ult, ListaPtr el)
/* *ult e' l'ultimo elemento della lista concatenata 
*in input lista, mentre el e' un nodo da agganciare in coda a lista.
*postc: inserisce el in coda alla lista concatenata in input lista, agganciandolo a ult */
{ if (!(*ult)) {*lista= el; *ult = el;}
else {(*ult)-> next = el; (*ult) = (*ult) -> next;}
}

/* sol3*/
void separa3iter(ListaPtr L, ListaPtr *pl1, ListaPtr *pl2)
/*separa la lista in  due liste, la prima contiene i multipli di 3 e la seconda i rimanenti
nello stesso ordine che avevano nella lista di partenza e senza allocare memoria.
postc: restituisce la lista dei multipli di 3 di L, estratti da L (nello stesso ordine in cui si trovano in L ) */ 
{	ListaPtr *aux1 = pl1; /* per appendere in coda alla prima lista risultato */
	ListaPtr *aux2 = pl2; /* per appendere in coda alla seconda lista risultato */
	
	/* scandisco lista di input */
	while (L != NULL) {
		if (L -> elem % 3 == 0) {
			/* aggiunge l' elemento alla fine della prima lista  */
			*aux1 = L;
/*la prima volta mette il puntatore alla testa della lista anche in pl1, 
 *le successive aux1 contiene l'indirizzo al successivo dell'ultimo agganciato, anche nella lista di testa pl1*/
			aux1 = &((*aux1)->next);
		} else {
		/* aggiunge l' elemento alla fine della seconda lista, analogamente alla prima  */
			*aux2 = L;
			aux2 = &((*aux2)->next);
		}
		L = L->next;
	}
	/* le liste */
	*aux1 = *aux2 = NULL;
}

/* sol4*/
void separa3ric(ListaPtr L,ListaPtr *pl1,ListaPtr *pl2) 
{if (L == NULL) 
	{*pl1 = *pl2 = NULL;} 
else 
	{/* separo la coda della lista */
	separa3ric(L->next, pl1, pl2);
	/* aggiungo elemento in testa ad una delle due liste */
	if (L->elem % 3 == 0) 
			{L->next = *pl1;
			*pl1 = L;
			} 
			else
			{L->next = *pl2;
			*pl2 = L;			}
	}
}

/* sol5, di Brandozzi, con qualche correzione*/
ListaPtr mult3(ListaPtr *L)
{ListaPtr L2;
L2 = NULL;
if (*L != NULL) mult3ric(L,&L2);
return L2;}

void mult3ric(ListaPtr *L1,ListaPtr *L2)
{ 
if (*L1 == NULL) {*L2 = NULL;return;}
if ((*L1) -> elem %3 == 0)
{ *L2 = *L1;
*L1 = (*L1) -> next;
mult3ric(L1,&((*L2) -> next));}
else mult3ric(&((*L1) -> next),L2);
}


/*secondo esercizio, sol1*/
int pariDisp(ListaPtr L)
/* questa non e' tail recursive
postc:restituisce 1 se la lista alterna elementi pari a quelli dispari,
*terminando con uno dispari, altrimenti restituisce 0*/
{int ris;
if (!L) return 0;
if (!L ->next) return (L->elem)%2==1; 
ris = pariDisp(L->next);
if ((L ->next ->elem)%2 ==1) return ris &&  (L->elem)%2 ==0;
else return ris && (L->elem)%2 ==1;
}  

/*secondo esercizio, sol2*/
int pariDispTR(ListaPtr L) 
/*questa  e' tail recursive
 * Verifica se la lista non vuota l contiene una sequenza alternata
 * pari-dispari di interi il cui ultimo elemento e' dispari. 
 *postc: restituisce 0 se la condizione e' falsa, 1 altrimenti*/	
{	if (L == NULL) return 0;
	if (L->next == NULL) return (L->elem % 2 == 1);
	if (L->next->elem % 2 == l->elem % 2)
		/* primi due elementi sono pari-pari o dispari-dispari */
		return 0;
	else
		return parDispTR(L->next);
}
